
var _typeof = require('@babel/runtime/helpers/typeof');
var _classCallCheck = require('@babel/runtime/helpers/classCallCheck');
var _createClass = require('@babel/runtime/helpers/createClass');
var _assertThisInitialized = require('@babel/runtime/helpers/assertThisInitialized');
var _inherits = require('@babel/runtime/helpers/inherits');
var _possibleConstructorReturn = require('@babel/runtime/helpers/possibleConstructorReturn');
var _getPrototypeOf = require('@babel/runtime/helpers/getPrototypeOf');
var React = require('react');
var PropTypes = require('prop-types');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var pdfjs = require('pdfjs-dist');
var pdfjsWorker = require('pdfjs-dist/build/pdf.worker.entry');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);
var _classCallCheck__default = /*#__PURE__*/_interopDefaultLegacy(_classCallCheck);
var _createClass__default = /*#__PURE__*/_interopDefaultLegacy(_createClass);
var _assertThisInitialized__default = /*#__PURE__*/_interopDefaultLegacy(_assertThisInitialized);
var _inherits__default = /*#__PURE__*/_interopDefaultLegacy(_inherits);
var _possibleConstructorReturn__default = /*#__PURE__*/_interopDefaultLegacy(_possibleConstructorReturn);
var _getPrototypeOf__default = /*#__PURE__*/_interopDefaultLegacy(_getPrototypeOf);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var PropTypes__default = /*#__PURE__*/_interopDefaultLegacy(PropTypes);
var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);
var _asyncToGenerator__default = /*#__PURE__*/_interopDefaultLegacy(_asyncToGenerator);
var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var pdfjs__default = /*#__PURE__*/_interopDefaultLegacy(pdfjs);
var pdfjsWorker__default = /*#__PURE__*/_interopDefaultLegacy(pdfjsWorker);
var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

var Alert = function Alert(_ref) {
  var message = _ref.message;
  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: "columns has-text-danger has-margin-top-5 is-mobile"
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column is-4 has-text-right has-padding-5"
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "error_outline"))), /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column is-8 has-text-left has-padding-5"
  }, /*#__PURE__*/React__default['default'].createElement("small", null, message)));
};

Alert.propTypes = {
  message: PropTypes__default['default'].string.isRequired
};

pdfjs__default['default'].GlobalWorkerOptions.workerSrc = pdfjsWorker__default['default'];
var pdf = null;

var RenderPdf = function RenderPdf(_ref) {
  var document = _ref.document,
      withCredentials = _ref.withCredentials,
      password = _ref.password,
      pageNum = _ref.pageNum,
      scale = _ref.scale,
      rotation = _ref.rotation,
      pageCount = _ref.pageCount,
      protectContent = _ref.protectContent,
      watermark = _ref.watermark,
      alert = _ref.alert,
      canvasCss = _ref.canvasCss;

  var _useState = React.useState({
    status: false,
    message: ''
  }),
      _useState2 = _slicedToArray__default['default'](_useState, 2),
      error = _useState2[0],
      setError = _useState2[1];

  var canvasRef = React.useRef(null);
  var thumbnailRef = React.useRef(null);
  var isInitialMount = React.useRef(true);
  var prevPageNum = React.useRef(pageNum);
  var AlertComponent = alert ? alert : Alert;

  var fetchPDF = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator__default['default']( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee() {
      var objDocInit;
      return _regeneratorRuntime__default['default'].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              objDocInit = {
                withCredentials: withCredentials,
                password: password
              };

              if (document.url == undefined) {
                objDocInit.data = atob(document.base64);
              } else {
                objDocInit.url = document.url;
              }

              _context.next = 5;
              return pdfjs__default['default'].getDocument(objDocInit).promise;

            case 5:
              pdf = _context.sent;
              _context.next = 8;
              return displayPage();

            case 8:
              _context.next = 10;
              return displayThumbnail();

            case 10:
              _context.next = 16;
              break;

            case 12:
              _context.prev = 12;
              _context.t0 = _context["catch"](0);
              console.warn('Error while opening the document !\n', _context.t0);
              setError({
                status: true,
                message: 'Error while opening the document !'
              });

            case 16:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 12]]);
    }));

    return function fetchPDF() {
      return _ref2.apply(this, arguments);
    };
  }();

  var displayPage = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator__default['default']( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee2() {
      var page, viewport, canvas, canvasContext, renderContext, renderTask, text, diagonal, opacity, font, size, color, metrics, width, height;
      return _regeneratorRuntime__default['default'].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return pdf.getPage(pageNum);

            case 3:
              page = _context2.sent;
              viewport = page.getViewport({
                scale: scale,
                rotation: rotation
              }); // Prepare canvas using PDF page dimensions

              canvas = canvasRef.current;
              canvas.height = viewport.height;
              canvas.width = viewport.width; // Render PDF page into canvas context

              canvasContext = canvas.getContext('2d');
              renderContext = {
                canvasContext: canvasContext,
                viewport: viewport
              };
              renderTask = page.render(renderContext);
              _context2.prev = 11;
              _context2.next = 14;
              return renderTask.promise;

            case 14:
              if (Object.entries(watermark).length !== 0) {
                //watermark config
                text = watermark.text, diagonal = watermark.diagonal, opacity = watermark.opacity, font = watermark.font, size = watermark.size, color = watermark.color; // setup watermark text for filling

                canvasContext.globalAlpha = opacity;
                canvasContext.font = "".concat(size * scale, "px ").concat(font !== '' ? font : 'Comic Sans MS');
                canvasContext.fillStyle = color; // get the metrics with font settings

                metrics = canvasContext.measureText(text);
                width = metrics.width;
                height = size * scale; // height is font size

                canvasContext.translate(viewport.width / 2, viewport.height / 2); // rotate the context and center the text

                if (diagonal) {
                  canvasContext.rotate(-0.785);
                }

                canvasContext.fillText(text, -width / 2, height / 2);
              } // call pageCountfunction


              pageCount(pdf.numPages);
              _context2.next = 22;
              break;

            case 18:
              _context2.prev = 18;
              _context2.t0 = _context2["catch"](11);
              console.warn('Error occured while rendering !\n', _context2.t0);
              setError({
                status: true,
                message: 'Error occured while rendering !'
              });

            case 22:
              _context2.next = 28;
              break;

            case 24:
              _context2.prev = 24;
              _context2.t1 = _context2["catch"](0);
              console.warn('Error while reading the pages !\n', _context2.t1);
              setError({
                status: true,
                message: 'Error while reading the pages !'
              });

            case 28:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[0, 24], [11, 18]]);
    }));

    return function displayPage() {
      return _ref3.apply(this, arguments);
    };
  }();

  var displayThumbnail = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator__default['default']( /*#__PURE__*/_regeneratorRuntime__default['default'].mark(function _callee3() {
      var tc;
      return _regeneratorRuntime__default['default'].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              tc = document.getElementById('thumbnail-container'); // console.log(tc.backgroundColor)
              // tc.props.style.display = 'flex'
              // tc.props.style.flexDirection = 'row'
              // tc.props.style.overflowX = 'auto'

            case 1:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function displayThumbnail() {
      return _ref4.apply(this, arguments);
    };
  }();

  React.useEffect(function () {
    fetchPDF();
  }, [document, password]);
  React.useEffect(function () {
    if (isInitialMount.current) {
      isInitialMount.current = false;
    } else {
      displayPage(); // displayThumbnail()
    }
  }, [pageNum, scale, rotation, pageCount]);

  if (error.status) {
    pageCount(-1);
    return /*#__PURE__*/React__default['default'].createElement(AlertComponent, {
      message: error.message
    });
  } else {
    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement("div", {
      className: canvasCss ? canvasCss : '',
      style: canvasCss ? {} : {
        height: '1000px',
        overflow: 'auto'
      }
    }, /*#__PURE__*/React__default['default'].createElement("canvas", {
      onContextMenu: function onContextMenu(e) {
        return protectContent ? e.preventDefault() : null;
      },
      ref: canvasRef,
      width: typeof window !== 'undefined' && window.innerWidth,
      height: typeof window !== 'undefined' && window.innerHeight
    })), /*#__PURE__*/React__default['default'].createElement("div", {
      ref: thumbnailRef,
      id: "thumbnail-container",
      style: {
        backgroundColor: '#EAE6DA'
      }
    }));
  }
};

RenderPdf.propTypes = {
  document: PropTypes__default['default'].any.isRequired,
  withCredentials: PropTypes__default['default'].bool,
  password: PropTypes__default['default'].string,
  pageNum: PropTypes__default['default'].number.isRequired,
  scale: PropTypes__default['default'].number.isRequired,
  rotation: PropTypes__default['default'].number.isRequired,
  pageCount: PropTypes__default['default'].func,
  protectContent: PropTypes__default['default'].bool,
  watermark: PropTypes__default['default'].shape({
    text: PropTypes__default['default'].string,
    diagonal: PropTypes__default['default'].bool,
    opacity: PropTypes__default['default'].string,
    size: PropTypes__default['default'].string,
    color: PropTypes__default['default'].string
  }),
  canvasCss: PropTypes__default['default'].string
};
RenderPdf.defaultProps = {
  pageCount: function pageCount() {},
  protectContent: false,
  watermark: {},
  canvasCss: ''
};

var NextPageButton = function NextPageButton(_ref) {
  var css = _ref.css,
      page = _ref.page,
      pages = _ref.pages,
      handleNextClick = _ref.handleNextClick;
  var nextClass = css || 'button is-black is-marginless';

  if (page === pages) {
    return /*#__PURE__*/React__default['default'].createElement("button", {
      className: nextClass,
      disabled: true
    }, /*#__PURE__*/React__default['default'].createElement("span", {
      className: "icon is-small"
    }, /*#__PURE__*/React__default['default'].createElement("i", {
      className: "material-icons"
    }, "keyboard_arrow_right")));
  }

  return /*#__PURE__*/React__default['default'].createElement("button", {
    className: nextClass,
    onClick: handleNextClick
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon is-small"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "keyboard_arrow_right")));
};

NextPageButton.propTypes = {
  css: PropTypes__default['default'].string,
  page: PropTypes__default['default'].number.isRequired,
  pages: PropTypes__default['default'].number.isRequired,
  handleNextClick: PropTypes__default['default'].func.isRequired
};

var PagesIndicator = function PagesIndicator(_ref) {
  var css = _ref.css,
      page = _ref.page,
      pages = _ref.pages;
  var pagesClass = css || 'is-size-7 is-vcentered has-text-centered is-inline-flex has-padding-top-5 button is-black is-marginless has-margin-left-5 has-margin-right-5';
  return /*#__PURE__*/React__default['default'].createElement("span", {
    className: pagesClass
  }, "Page ".concat(page, " / ").concat(pages));
};

PagesIndicator.propTypes = {
  css: PropTypes__default['default'].string,
  page: PropTypes__default['default'].number.isRequired,
  pages: PropTypes__default['default'].number.isRequired
};

var PreviousPageButton = function PreviousPageButton(_ref) {
  var css = _ref.css,
      page = _ref.page,
      handlePrevClick = _ref.handlePrevClick;
  var prevClass = css || 'button is-black is-marginless';

  if (page === 1) {
    return /*#__PURE__*/React__default['default'].createElement("button", {
      className: prevClass,
      disabled: true
    }, /*#__PURE__*/React__default['default'].createElement("span", {
      className: "icon is-small"
    }, /*#__PURE__*/React__default['default'].createElement("i", {
      className: "material-icons"
    }, "keyboard_arrow_left")));
  }

  return /*#__PURE__*/React__default['default'].createElement("button", {
    className: prevClass,
    onClick: handlePrevClick
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon is-small"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "keyboard_arrow_left")));
};

PreviousPageButton.propTypes = {
  css: PropTypes__default['default'].string,
  page: PropTypes__default['default'].number.isRequired,
  handlePrevClick: PropTypes__default['default'].func.isRequired
};

var ZoomIn = function ZoomIn(_ref) {
  var css = _ref.css,
      scale = _ref.scale,
      defaultScale = _ref.defaultScale,
      maxScale = _ref.maxScale,
      handleZoomIn = _ref.handleZoomIn;
  var zoomInClass = css || 'button is-black is-marginless has-margin-left-5 has-margin-right-5';
  var checkScale = maxScale;

  if (defaultScale > maxScale) {
    checkScale = defaultScale;
  }

  if (scale.toFixed(2) === checkScale.toFixed(2)) {
    return /*#__PURE__*/React__default['default'].createElement("button", {
      className: zoomInClass,
      disabled: true
    }, /*#__PURE__*/React__default['default'].createElement("span", {
      className: "icon is-small"
    }, /*#__PURE__*/React__default['default'].createElement("i", {
      className: "material-icons"
    }, "zoom_in")));
  }

  return /*#__PURE__*/React__default['default'].createElement("button", {
    className: zoomInClass,
    onClick: handleZoomIn
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon is-small"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "zoom_in")));
};

ZoomIn.propTypes = {
  css: PropTypes__default['default'].string,
  scale: PropTypes__default['default'].number.isRequired,
  defaultScale: PropTypes__default['default'].number.isRequired,
  maxScale: PropTypes__default['default'].number.isRequired,
  handleZoomIn: PropTypes__default['default'].func.isRequired
};

var ZoomOut = function ZoomOut(_ref) {
  var css = _ref.css,
      scale = _ref.scale,
      defaultScale = _ref.defaultScale,
      minScale = _ref.minScale,
      handleZoomOut = _ref.handleZoomOut;
  var zoomOutClass = css || 'button is-black is-marginless has-margin-left-5 has-margin-right-5';
  var checkScale = minScale;

  if (defaultScale < minScale) {
    checkScale = defaultScale;
  }

  if (scale.toFixed(2) === checkScale.toFixed(2)) {
    return /*#__PURE__*/React__default['default'].createElement("button", {
      className: zoomOutClass,
      disabled: true
    }, /*#__PURE__*/React__default['default'].createElement("span", {
      className: "icon is-small"
    }, /*#__PURE__*/React__default['default'].createElement("i", {
      className: "material-icons"
    }, "zoom_out")));
  }

  return /*#__PURE__*/React__default['default'].createElement("button", {
    className: zoomOutClass,
    onClick: handleZoomOut
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon is-small"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "zoom_out")));
};

ZoomOut.propTypes = {
  css: PropTypes__default['default'].string,
  scale: PropTypes__default['default'].number.isRequired,
  defaultScale: PropTypes__default['default'].number.isRequired,
  minScale: PropTypes__default['default'].number.isRequired,
  handleZoomOut: PropTypes__default['default'].func.isRequired
};

var ResetZoom = function ResetZoom(_ref) {
  var css = _ref.css,
      scale = _ref.scale,
      defaultScale = _ref.defaultScale,
      handleResetZoom = _ref.handleResetZoom;
  var resetZoomClass = css || 'button is-black is-marginless has-margin-left-5 has-margin-right-5';

  if (scale.toFixed(2) === defaultScale.toFixed(2)) {
    return /*#__PURE__*/React__default['default'].createElement("button", {
      className: resetZoomClass,
      disabled: true
    }, /*#__PURE__*/React__default['default'].createElement("span", {
      className: "icon is-small"
    }, /*#__PURE__*/React__default['default'].createElement("i", {
      className: "material-icons"
    }, "refresh")));
  }

  return /*#__PURE__*/React__default['default'].createElement("button", {
    className: resetZoomClass,
    onClick: handleResetZoom
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon is-small"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "refresh")));
};

ResetZoom.propTypes = {
  css: PropTypes__default['default'].string,
  scale: PropTypes__default['default'].number.isRequired,
  defaultScale: PropTypes__default['default'].number.isRequired,
  handleResetZoom: PropTypes__default['default'].func.isRequired
};

var RotateLeft = function RotateLeft(_ref) {
  var css = _ref.css,
      rotationAngle = _ref.rotationAngle,
      handleRotateLeft = _ref.handleRotateLeft;
  var rotateLeftClass = css || 'button is-black is-marginless has-margin-left-5 has-margin-right-5';

  if (rotationAngle === -90) {
    return /*#__PURE__*/React__default['default'].createElement("button", {
      className: rotateLeftClass,
      disabled: true
    }, /*#__PURE__*/React__default['default'].createElement("span", {
      className: "icon is-small"
    }, /*#__PURE__*/React__default['default'].createElement("i", {
      className: "material-icons"
    }, "rotate_left")));
  }

  return /*#__PURE__*/React__default['default'].createElement("button", {
    className: rotateLeftClass,
    onClick: handleRotateLeft
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon is-small"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "rotate_left")));
};

RotateLeft.propTypes = {
  css: PropTypes__default['default'].string,
  rotationAngle: PropTypes__default['default'].number.isRequired,
  handleRotateLeft: PropTypes__default['default'].func.isRequired
};

var ResetRotation = function ResetRotation(_ref) {
  var css = _ref.css,
      rotationAngle = _ref.rotationAngle,
      handleResetRotation = _ref.handleResetRotation;
  var resetRotationClass = css || 'button is-black is-marginless has-margin-left-5 has-margin-right-5';

  if (rotationAngle === 0) {
    return /*#__PURE__*/React__default['default'].createElement("button", {
      className: resetRotationClass,
      disabled: true
    }, /*#__PURE__*/React__default['default'].createElement("span", {
      className: "icon is-small"
    }, /*#__PURE__*/React__default['default'].createElement("i", {
      className: "material-icons"
    }, "refresh")));
  }

  return /*#__PURE__*/React__default['default'].createElement("button", {
    className: resetRotationClass,
    onClick: handleResetRotation
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon is-small"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "refresh")));
};

ResetRotation.propTypes = {
  css: PropTypes__default['default'].string,
  rotationAngle: PropTypes__default['default'].number.isRequired,
  handleResetRotation: PropTypes__default['default'].func.isRequired
};

var RotateRight = function RotateRight(_ref) {
  var css = _ref.css,
      rotationAngle = _ref.rotationAngle,
      handleRotateRight = _ref.handleRotateRight;
  var rotateRightClass = css || 'button is-black is-marginless has-margin-left-5 has-margin-right-5';

  if (rotationAngle === 90) {
    return /*#__PURE__*/React__default['default'].createElement("button", {
      className: rotateRightClass,
      disabled: true
    }, /*#__PURE__*/React__default['default'].createElement("span", {
      className: "icon is-small"
    }, /*#__PURE__*/React__default['default'].createElement("i", {
      className: "material-icons"
    }, "rotate_right")));
  }

  return /*#__PURE__*/React__default['default'].createElement("button", {
    className: rotateRightClass,
    onClick: handleRotateRight
  }, /*#__PURE__*/React__default['default'].createElement("span", {
    className: "icon is-small"
  }, /*#__PURE__*/React__default['default'].createElement("i", {
    className: "material-icons"
  }, "rotate_right")));
};

RotateRight.propTypes = {
  css: PropTypes__default['default'].string,
  rotationAngle: PropTypes__default['default'].number.isRequired,
  handleRotateRight: PropTypes__default['default'].func.isRequired
};

var Navigation = function Navigation(_ref) {
  var page = _ref.page,
      pages = _ref.pages,
      scale = _ref.scale,
      defaultScale = _ref.defaultScale,
      maxScale = _ref.maxScale,
      minScale = _ref.minScale,
      rotationAngle = _ref.rotationAngle,
      hideZoom = _ref.hideZoom,
      hideRotation = _ref.hideRotation,
      css = _ref.css,
      handlePrevClick = _ref.handlePrevClick,
      handleNextClick = _ref.handleNextClick,
      handleZoomIn = _ref.handleZoomIn,
      handleResetZoom = _ref.handleResetZoom,
      handleZoomOut = _ref.handleZoomOut,
      handleRotateLeft = _ref.handleRotateLeft,
      handleResetRotation = _ref.handleResetRotation,
      handleRotateRight = _ref.handleRotateRight;
  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: "columns is-gapless ".concat(css.navbarWrapper || 'box is-mobile has-text-white has-background-black has-margin-top-15 has-margin-bottom-15')
  }, hideZoom ? /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column is-2"
  }) : /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column is-2 buttons are-small has-addons"
  }, /*#__PURE__*/React__default['default'].createElement(ZoomOut, {
    scale: scale,
    minScale: minScale,
    defaultScale: defaultScale,
    css: css.zoomOutBtn,
    handleZoomOut: handleZoomOut
  }), /*#__PURE__*/React__default['default'].createElement(ResetZoom, {
    scale: scale,
    defaultScale: defaultScale,
    css: css.resetZoomBtn,
    handleResetZoom: handleResetZoom
  }), /*#__PURE__*/React__default['default'].createElement(ZoomIn, {
    scale: scale,
    maxScale: maxScale,
    defaultScale: defaultScale,
    css: css.zoomInBtn,
    handleZoomIn: handleZoomIn
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column"
  }), /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column is-3 buttons are-small has-addons is-centered"
  }, /*#__PURE__*/React__default['default'].createElement(PreviousPageButton, {
    css: css.previousPageBtn,
    page: page,
    pages: pages,
    handlePrevClick: handlePrevClick
  }), /*#__PURE__*/React__default['default'].createElement(PagesIndicator, {
    css: css.pageIndicator,
    page: page,
    pages: pages
  }), /*#__PURE__*/React__default['default'].createElement(NextPageButton, {
    css: css.nextPageBtn,
    page: page,
    pages: pages,
    handleNextClick: handleNextClick
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column"
  }), hideRotation ? /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column is-2"
  }) : /*#__PURE__*/React__default['default'].createElement("div", {
    className: "column is-2 buttons are-small has-addons is-right"
  }, /*#__PURE__*/React__default['default'].createElement(RotateLeft, {
    css: css.rotateLeftBtn,
    rotationAngle: rotationAngle,
    handleRotateLeft: handleRotateLeft
  }), /*#__PURE__*/React__default['default'].createElement(ResetRotation, {
    css: css.resetRotationBtn,
    rotationAngle: rotationAngle,
    handleResetRotation: handleResetRotation
  }), /*#__PURE__*/React__default['default'].createElement(RotateRight, {
    css: css.rotateRightBtn,
    rotationAngle: rotationAngle,
    handleRotateRight: handleRotateRight
  })));
};

Navigation.propTypes = {
  page: PropTypes__default['default'].number.isRequired,
  pages: PropTypes__default['default'].number.isRequired,
  scale: PropTypes__default['default'].number,
  defaultScale: PropTypes__default['default'].number,
  maxScale: PropTypes__default['default'].number,
  minScale: PropTypes__default['default'].number,
  rotationAngle: PropTypes__default['default'].number,
  hideZoom: PropTypes__default['default'].bool,
  hideRotation: PropTypes__default['default'].bool,
  css: PropTypes__default['default'].shape({
    navbarWrapper: PropTypes__default['default'].string,
    pages: PropTypes__default['default'].string,
    pageIndicator: PropTypes__default['default'].string,
    previousPageBtn: PropTypes__default['default'].string,
    nextPageBtn: PropTypes__default['default'].string,
    zoomOutBtn: PropTypes__default['default'].string,
    resetZoomBtn: PropTypes__default['default'].string,
    zoomInBtn: PropTypes__default['default'].string,
    rotateLeftBtn: PropTypes__default['default'].string,
    resetRotationBtn: PropTypes__default['default'].string,
    rotateRightBtn: PropTypes__default['default'].string
  }),
  elements: PropTypes__default['default'].shape({
    previousPageBtn: PropTypes__default['default'].any,
    nextPageBtn: PropTypes__default['default'].any,
    pages: PropTypes__default['default'].any
  }),
  handlePrevClick: PropTypes__default['default'].func.isRequired,
  handleNextClick: PropTypes__default['default'].func.isRequired,
  handleZoomIn: PropTypes__default['default'].func.isRequired,
  handleResetZoom: PropTypes__default['default'].func.isRequired,
  handleZoomOut: PropTypes__default['default'].func.isRequired,
  handleRotateLeft: PropTypes__default['default'].func.isRequired,
  handleResetRotation: PropTypes__default['default'].func.isRequired,
  handleRotateRight: PropTypes__default['default'].func.isRequired
};
Navigation.defaultProps = {
  css: {},
  elements: {}
};

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty__default['default'](target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var loader = {
  display: 'inline-block',
  verticalAlign: 'text-bottom',
  backgroundColor: 'currentColor',
  borderRadius: '50%',
  opacity: 0,
  width: '0.5rem',
  height: '0.5rem',
  animationDuration: '0.75s',
  animationTimingFunction: 'linear',
  animationIterationCount: 'infinite',
  animationDirection: 'normal',
  animationFillMode: 'none',
  animationPlayState: 'running',
  animationName: 'spinner-grow'
};

var loader1 = _objectSpread(_objectSpread({}, loader), {}, {
  animationDelay: '0s'
});

var loader2 = _objectSpread(_objectSpread({}, loader), {}, {
  animationDelay: '0.25s'
});

var loader3 = _objectSpread(_objectSpread({}, loader), {}, {
  animationDelay: '0.5s'
});

var Loader = function Loader() {
  return /*#__PURE__*/React__default['default'].createElement("div", {
    className: "flex-row has-margin-10 justify-center align-items-flex-end"
  }, /*#__PURE__*/React__default['default'].createElement("p", {
    className: "is-size-3 flex-column is-marginless"
  }, "Loading"), /*#__PURE__*/React__default['default'].createElement("div", {
    className: "flex-column has-padding-10"
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    style: loader1
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: "flex-column has-padding-10"
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    style: loader2
  })), /*#__PURE__*/React__default['default'].createElement("div", {
    className: "flex-column has-padding-10"
  }, /*#__PURE__*/React__default['default'].createElement("div", {
    style: loader3
  })));
};

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf__default['default'](Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf__default['default'](this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn__default['default'](this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

try {
  require('bulma/css/bulma.css');

  require('bulma-helpers/css/bulma-helpers.min.css');

  require('material-design-icons/iconfont/material-icons.css');
} catch (error) {}

var PDFViewer = /*#__PURE__*/function (_React$Component) {
  _inherits__default['default'](PDFViewer, _React$Component);

  var _super = _createSuper(PDFViewer);

  function PDFViewer(props) {
    var _this;

    _classCallCheck__default['default'](this, PDFViewer);

    _this = _super.call(this, props);
    _this.state = {
      page: _this.props.page,
      pages: 0,
      scale: _this.props.scale,
      defaultScale: _this.props.scale,
      rotationAngle: _this.props.rotationAngle,
      isReady: false
    };
    _this.getPageCount = _this.getPageCount.bind(_assertThisInitialized__default['default'](_this));
    _this.handlePrevClick = _this.handlePrevClick.bind(_assertThisInitialized__default['default'](_this));
    _this.handleNextClick = _this.handleNextClick.bind(_assertThisInitialized__default['default'](_this));
    _this.handleZoomIn = _this.handleZoomIn.bind(_assertThisInitialized__default['default'](_this));
    _this.handleResetZoom = _this.handleResetZoom.bind(_assertThisInitialized__default['default'](_this));
    _this.handleZoomOut = _this.handleZoomOut.bind(_assertThisInitialized__default['default'](_this));
    _this.handleRotateLeft = _this.handleRotateLeft.bind(_assertThisInitialized__default['default'](_this));
    _this.handleResetRotation = _this.handleResetRotation.bind(_assertThisInitialized__default['default'](_this));
    _this.handleRotateRight = _this.handleRotateRight.bind(_assertThisInitialized__default['default'](_this));
    return _this;
  }

  _createClass__default['default'](PDFViewer, [{
    key: "getPageCount",
    value: function getPageCount(pages) {
      if (this.state.pages !== pages) {
        this.setState({
          pages: pages,
          isReady: true
        });

        if (this.props.getMaxPageCount) {
          this.props.getMaxPageCount(pages);
        }
      }
    }
  }, {
    key: "handlePrevClick",
    value: function handlePrevClick() {
      if (this.state.page === 1) return;
      this.setState({
        page: this.state.page - 1
      });

      if (this.props.onPrevBtnClick) {
        this.props.onPrevBtnClick(this.state.page - 1);
      }
    }
  }, {
    key: "handleNextClick",
    value: function handleNextClick() {
      if (this.state.page === this.pages) return;
      this.setState({
        page: this.state.page + 1
      });

      if (this.props.onNextBtnClick) {
        this.props.onNextBtnClick(this.state.page + 1);
      }
    }
  }, {
    key: "handleZoomIn",
    value: function handleZoomIn() {
      var checkScale = this.props.maxScale;

      if (this.state.defaultScale > this.props.maxScale) {
        checkScale = this.state.defaultScale;
      }

      if (this.state.scale < checkScale) {
        this.setState({
          scale: this.state.scale + this.props.scaleStep
        });
      }

      if (this.props.onZoom) {
        this.props.onZoom(this.state.scale + this.props.scaleStep);
      }
    }
  }, {
    key: "handleResetZoom",
    value: function handleResetZoom() {
      this.setState({
        scale: this.state.defaultScale
      });

      if (this.props.onZoom) {
        this.props.onZoom(this.state.defaultScale);
      }
    }
  }, {
    key: "handleZoomOut",
    value: function handleZoomOut() {
      var checkScale = this.props.minScale;

      if (this.state.defaultScale < this.props.minScale) {
        checkScale = this.state.defaultScale;
      }

      if (this.state.scale > checkScale) {
        this.setState({
          scale: this.state.scale - this.props.scaleStep
        });
      }

      if (this.props.onZoom) {
        this.props.onZoom(this.state.scale - this.props.scaleStep);
      }
    }
  }, {
    key: "handleRotateLeft",
    value: function handleRotateLeft() {
      if (this.state.rotationAngle !== -90) {
        this.setState({
          rotationAngle: -90
        });
      }

      if (this.props.onRotation) {
        this.props.onRotation(-90);
      }
    }
  }, {
    key: "handleResetRotation",
    value: function handleResetRotation() {
      if (this.state.rotationAngle !== 0) {
        this.setState({
          rotationAngle: 0
        });
      }

      if (this.props.onRotation) {
        this.props.onRotation(0);
      }
    }
  }, {
    key: "handleRotateRight",
    value: function handleRotateRight() {
      if (this.state.rotationAngle !== 90) {
        this.setState({
          rotationAngle: 90
        });
      }

      if (this.props.onRotation) {
        this.props.onRotation(90);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          document = _this$props.document,
          withCredentials = _this$props.withCredentials,
          password = _this$props.password,
          loader = _this$props.loader,
          maxScale = _this$props.maxScale,
          minScale = _this$props.minScale,
          hideNavbar = _this$props.hideNavbar,
          hideZoom = _this$props.hideZoom,
          hideRotation = _this$props.hideRotation,
          navbarOnTop = _this$props.navbarOnTop,
          navigation = _this$props.navigation,
          css = _this$props.css,
          canvasCss = _this$props.canvasCss,
          onDocumentClick = _this$props.onDocumentClick,
          protectContent = _this$props.protectContent,
          watermark = _this$props.watermark,
          alert = _this$props.alert;
      var _this$state = this.state,
          page = _this$state.page,
          pages = _this$state.pages,
          scale = _this$state.scale,
          defaultScale = _this$state.defaultScale,
          rotationAngle = _this$state.rotationAngle;
      var NavigationElement = navigation;
      var pdf = /*#__PURE__*/React__default['default'].createElement(RenderPdf, {
        document: document,
        withCredentials: withCredentials,
        password: password,
        pageNum: page,
        scale: scale,
        rotation: rotationAngle,
        pageCount: function pageCount(num) {
          return _this2.getPageCount(num);
        },
        protectContent: protectContent,
        watermark: watermark,
        alert: alert,
        canvasCss: canvasCss
      });
      var nav = null;

      if (!hideNavbar && pages > 0) {
        nav = !navigation || navigation && _typeof__default['default'](navigation) === 'object' ? /*#__PURE__*/React__default['default'].createElement(Navigation, {
          page: page,
          pages: pages,
          scale: scale,
          defaultScale: defaultScale,
          maxScale: maxScale,
          minScale: minScale,
          rotationAngle: rotationAngle,
          hideZoom: hideZoom,
          hideRotation: hideRotation,
          css: navigation ? navigation.css : undefined,
          handleNextClick: this.handleNextClick,
          handlePrevClick: this.handlePrevClick,
          handleZoomIn: this.handleZoomIn,
          handleResetZoom: this.handleResetZoom,
          handleZoomOut: this.handleZoomOut,
          handleRotateLeft: this.handleRotateLeft,
          handleResetRotation: this.handleResetRotation,
          handleRotateRight: this.handleRotateRight
        }) : /*#__PURE__*/React__default['default'].createElement(NavigationElement, {
          page: page,
          pages: pages,
          scale: scale,
          defaultScale: defaultScale,
          maxScale: maxScale,
          minScale: minScale,
          rotationAngle: rotationAngle,
          hideZoom: hideZoom,
          hideRotation: hideRotation,
          handleNextClick: this.handleNextClick,
          handlePrevClick: this.handlePrevClick,
          handleZoomIn: this.handleZoomIn,
          handleResetZoom: this.handleResetZoom,
          handleZoomOut: this.handleZoomOut,
          handleRotateLeft: this.handleRotateLeft,
          handleResetRotation: this.handleResetRotation,
          handleRotateRight: this.handleRotateRight
        });
      }

      return /*#__PURE__*/React__default['default'].createElement("div", {
        className: css ? css : 'container text-center'
      }, /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
          display: this.state.isReady ? 'none' : 'block'
        }
      }, /*#__PURE__*/React__default['default'].createElement("div", {
        className: canvasCss ? canvasCss : '',
        style: canvasCss ? {} : {
          height: '1000px',
          overflow: 'auto'
        }
      }, loader ? loader : /*#__PURE__*/React__default['default'].createElement(Loader, null))), /*#__PURE__*/React__default['default'].createElement("div", {
        style: {
          display: this.state.isReady ? 'block' : 'none'
        }
      }, navbarOnTop ? /*#__PURE__*/React__default['default'].createElement("div", null, /*#__PURE__*/React__default['default'].createElement("div", null, nav), /*#__PURE__*/React__default['default'].createElement("div", {
        // className={canvasCss ? canvasCss : ''}
        // style={
        //     canvasCss
        //         ? {}
        //         : {
        //               height: '1000px',
        //               overflow: 'auto',
        //           }
        // }>
        onClick: onDocumentClick
      }, pdf)) : /*#__PURE__*/React__default['default'].createElement("div", null, /*#__PURE__*/React__default['default'].createElement("div", {
        // className={canvasCss ? canvasCss : ''}
        // style={
        //     canvasCss
        //         ? {}
        //         : {
        //               height: '1000px',
        //               overflow: 'auto',
        //           }
        // }
        onClick: onDocumentClick
      }, pdf), /*#__PURE__*/React__default['default'].createElement("div", null, nav))));
    }
  }]);

  return PDFViewer;
}(React__default['default'].Component);

PDFViewer.propTypes = {
  document: PropTypes__default['default'].shape({
    url: PropTypes__default['default'].string,
    // File path
    base64: PropTypes__default['default'].string // PDF file encoded in base64

  }).isRequired,
  withCredentials: PropTypes__default['default'].bool,
  password: PropTypes__default['default'].string,
  loader: PropTypes__default['default'].node,
  page: PropTypes__default['default'].number,
  scale: PropTypes__default['default'].number,
  scaleStep: PropTypes__default['default'].number,
  maxScale: PropTypes__default['default'].number,
  minScale: PropTypes__default['default'].number,
  css: PropTypes__default['default'].string,
  canvasCss: PropTypes__default['default'].string,
  rotationAngle: PropTypes__default['default'].number,
  onDocumentClick: PropTypes__default['default'].func,
  onPrevBtnClick: PropTypes__default['default'].func,
  onNextBtnClick: PropTypes__default['default'].func,
  onZoom: PropTypes__default['default'].func,
  onRotation: PropTypes__default['default'].func,
  getMaxPageCount: PropTypes__default['default'].func,
  hideNavbar: PropTypes__default['default'].bool,
  navbarOnTop: PropTypes__default['default'].bool,
  hideZoom: PropTypes__default['default'].bool,
  hideRotation: PropTypes__default['default'].bool,
  protectContent: PropTypes__default['default'].bool,
  watermark: PropTypes__default['default'].shape({
    text: PropTypes__default['default'].string,
    diagonal: PropTypes__default['default'].bool,
    opacity: PropTypes__default['default'].string,
    font: PropTypes__default['default'].string,
    size: PropTypes__default['default'].string,
    color: PropTypes__default['default'].string
  }),
  alert: PropTypes__default['default'].any,
  navigation: PropTypes__default['default'].oneOfType([// Can be an object with css classes or react elements to be rendered
  PropTypes__default['default'].shape({
    css: PropTypes__default['default'].shape({
      navbarWrapper: PropTypes__default['default'].string,
      zoomOutBtn: PropTypes__default['default'].string,
      resetZoomBtn: PropTypes__default['default'].string,
      zoomInBtn: PropTypes__default['default'].string,
      previousPageBtn: PropTypes__default['default'].string,
      pageIndicator: PropTypes__default['default'].string,
      nextPageBtn: PropTypes__default['default'].string,
      rotateLeftBtn: PropTypes__default['default'].string,
      resetRotationBtn: PropTypes__default['default'].string,
      rotateRightBtn: PropTypes__default['default'].string
    })
  }), // Or a full navigation component
  PropTypes__default['default'].any])
};
PDFViewer.defaultProps = {
  page: 1,
  withCredentials: false,
  password: '',
  defaultScale: 1,
  scale: 1,
  scaleStep: 1,
  maxScale: 3,
  minScale: 1,
  rotationAngle: 0,
  hideNavbar: false,
  hideZoom: false,
  hideRotation: false,
  navbarOnTop: false,
  canvasCss: ''
};

module.exports = PDFViewer;
